diff -ruN ../nakedmudv3.7/src/scripts/trighooks.c src/scripts/trighooks.c
--- ../nakedmudv3.7/src/scripts/trighooks.c	2008-12-06 01:29:26.000000000 -0500
+++ src/scripts/trighooks.c	2009-03-02 01:08:22.000000000 -0500
@@ -71,35 +71,42 @@
 		 const char *arg, LIST *optional) {
   // make our basic dictionary, and fill it up with these new variables
   PyObject *dict = restricted_script_dict();
+  LIST *varnames = newList(); 
   // now, import all of our variables
   if(command) {
     PyObject *pycmd = PyString_FromString(command);
     PyDict_SetItemString(dict, "cmd", pycmd);
+    listPut(varnames, strdup("cmd"));
     Py_DECREF(pycmd);
   }
   if(arg) {
     PyObject *pyarg = PyString_FromString(arg);
     PyDict_SetItemString(dict, "arg", pyarg);
+    listPut(varnames, strdup("arg"));
     Py_DECREF(pyarg);
   }
   if(ch) {
     PyObject *pych = charGetPyForm(ch);
     PyDict_SetItemString(dict, "ch", pych);
+    listPut(varnames, strdup("ch"));
     Py_DECREF(pych);
   }
   if(room) {
     PyObject *pyroom = roomGetPyForm(room);
     PyDict_SetItemString(dict, "room", pyroom);
+    listPut(varnames, strdup("room"));
     Py_DECREF(pyroom);
   }    
   if(obj) {
     PyObject *pyobj = objGetPyForm(obj);
     PyDict_SetItemString(dict, "obj", pyobj);
+    listPut(varnames, strdup("obj"));
     Py_DECREF(pyobj);
   }
   if(exit) {
     PyObject *pyexit = newPyExit(exit);
     PyDict_SetItemString(dict, "ex", pyexit);
+    listPut(varnames, strdup("ex"));
     Py_DECREF(pyexit);
   }
 
@@ -112,6 +119,7 @@
     case VARTYPE_ROOM:  pyme = roomGetPyForm(me); break;
     }
     PyDict_SetItemString(dict, "me", pyme);
+    listPut(varnames, strdup("me"));
     Py_DECREF(pyme);
   }
 
@@ -128,19 +136,34 @@
       case VARTYPE_ROOM:  pyopt = roomGetPyForm(opt->data); break;
       }
       PyDict_SetItemString(dict, opt->name, pyopt);
+      listPut(varnames, strdup(opt->name));
       Py_XDECREF(pyopt);
     } deleteListIterator(opt_i);
   }
 
   // run the script, then kill our dictionary
   triggerRun(trig, dict);
-  Py_DECREF(dict);
+
+  // if triggers create methods, it increases the reference count on our
+  // dictionary. This is a known memory leak. We'll try to mitigate it by
+  // cleaning out some of the contents. A better solution is needed, that
+  // makes sure the dictionary itself is not leaked
+  LIST_ITERATOR *vname_i = newListIterator(varnames);
+  char            *vname = NULL;
+  ITERATE_LIST(vname, vname_i) {
+    PyDict_DelItemString(dict, vname);
+  } deleteListIterator(vname_i);
+  deleteListWith(varnames, free);
+  Py_XDECREF(dict);
 }
 
 
 //
 // handles all of a character's triggers
 void do_char_trigs(CHAR_DATA *ch, const char *type, void *thing, void *arg) {
+  if(ch == NULL)
+    return;
+
   if(listSize(charGetTriggers(ch)) > 0) {
     // first, build a list of all our triggers of this type
     LIST           *trigs = newList();
@@ -159,8 +182,12 @@
       ITERATE_LIST(trig, trig_i) {
 	if(!strcasecmp(type, "speech"))
 	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,arg,NULL);
-	else if(!strcasecmp(type, "move"))
+	else if(!strcasecmp(type, "look"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "self_exit"))
 	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,NULL,NULL,thing,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "self_enter"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 	else if(!strcasecmp(type, "enter"))
 	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,NULL,NULL);
 	else if(!strcasecmp(type, "exit"))
@@ -175,6 +202,8 @@
 	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,thing,NULL,NULL,NULL,NULL,NULL);
 	else if(!strcasecmp(type, "remove"))
 	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,thing,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "to_game"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 	else {
 	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
 		     type, charGetClass(ch), charGetUID(ch));
@@ -190,6 +219,9 @@
 //
 // handles all of an object's triggers
 void do_obj_trigs(OBJ_DATA *obj, const char *type, void *thing, void *arg) {
+  if(obj == NULL)
+    return;
+
   if(listSize(objGetTriggers(obj)) > 0) {
     // first, build a list of all our triggers of this type
     LIST           *trigs = newList();
@@ -223,6 +255,12 @@
 	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
 	else if(!strcasecmp(type, "open"))
 	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "close"))
+	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "look"))
+	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "to_game"))
+	  gen_do_trig(trig,obj,VARTYPE_OBJ,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 	else {
 	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
 		     type, objGetClass(obj), objGetUID(obj));
@@ -238,6 +276,9 @@
 //
 // handles all of a room's triggers
 void do_room_trigs(ROOM_DATA *rm, const char *type, void *thing, void *arg){
+  if(rm == NULL)
+    return;
+
   if(listSize(roomGetTriggers(rm)) > 0) {
     // first, build a list of all our triggers of this type
     LIST           *trigs = newList();
@@ -262,12 +303,18 @@
 	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,NULL,NULL,NULL,NULL);
 	else if(!strcasecmp(type, "exit"))
 	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,arg,NULL,NULL,NULL);
+ 	else if(!strcasecmp(type, "look"))
+ 	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,NULL,NULL,NULL,NULL);
 	else if(!strcasecmp(type, "speech"))
 	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,NULL,NULL,arg,NULL);
 	else if(!strcasecmp(type, "reset"))
 	  gen_do_trig(trig,rm,VARTYPE_ROOM,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 	else if(!strcasecmp(type, "open"))
 	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,arg,NULL,NULL,NULL);
+ 	else if(!strcasecmp(type, "close"))
+ 	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,arg,NULL,NULL,NULL);
+ 	else if(!strcasecmp(type, "to_game"))
+ 	  gen_do_trig(trig,rm,VARTYPE_ROOM,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
 	else {
 	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
 		     type, roomGetClass(rm), roomGetUID(rm));
@@ -326,6 +373,7 @@
       do_char_trigs(mob, "enter", ch, NULL);
   } deleteListIterator(mob_i);
   do_room_trigs(room, "enter", ch, NULL);
+  do_char_trigs(ch,   "self_enter", NULL, NULL);
 }
 
 void do_exit_trighooks(const char *info) {
@@ -341,7 +389,7 @@
       do_char_trigs(mob, "exit", ch, exit);
   } deleteListIterator(mob_i);
   do_room_trigs(room, "exit", ch,   exit);
-  do_char_trigs(ch,   "move", exit, NULL);
+  do_char_trigs(ch,   "self_exit", exit, NULL);
 }
 
 void do_ask_trighooks(const char *info) {
@@ -396,7 +444,6 @@
   char  *zone_key = NULL;
   hookParseInfo(info, &zone_key);
   ZONE_DATA *zone = worldGetZone(gameworld, zone_key);
-  free(zone_key);
 
   LIST_ITERATOR *res_i = newListIterator(zoneGetResettable(zone));
   char           *name = NULL;
@@ -406,6 +453,9 @@
     room = worldGetRoom(gameworld, get_fullkey(name, locale));
     if(room != NULL) do_room_trigs(room, "reset", NULL, NULL);
   } deleteListIterator(res_i);
+
+  // garbage collection
+  free(zone_key);
 }
 
 void do_open_door_trighooks(const char *info) {
@@ -422,6 +472,59 @@
   do_obj_trigs(obj, "open", ch, NULL);
 }
 
+void do_close_door_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  EXIT_DATA *ex = NULL;
+  hookParseInfo(info, &ch, &ex);
+  do_room_trigs(charGetRoom(ch), "close", ch, ex);
+}
+
+void do_close_obj_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  OBJ_DATA *obj = NULL;
+  hookParseInfo(info, &ch, &obj);
+  do_obj_trigs(obj, "close", ch, NULL);
+}
+
+void do_look_at_obj_trighooks(const char *info) {
+  OBJ_DATA     *obj = NULL;
+  CHAR_DATA *looker = NULL;
+  hookParseInfo(info, &obj, &looker);
+  do_obj_trigs(obj, "look", looker, NULL);
+}
+
+void do_look_at_room_trighooks(const char *info) {
+  ROOM_DATA   *room = NULL;
+  CHAR_DATA *looker = NULL;
+  hookParseInfo(info, &room, &looker);
+  do_room_trigs(room, "look", looker, NULL);
+}
+
+void do_look_at_char_trighooks(const char *info) {
+  CHAR_DATA     *ch = NULL;
+  CHAR_DATA *looker = NULL;
+  hookParseInfo(info, &ch, &looker);
+  do_char_trigs(ch, "look", looker, NULL);
+}
+
+void do_obj_to_game_trighooks(const char *info) {
+  OBJ_DATA *obj = NULL;
+  hookParseInfo(info, &obj);
+  do_obj_trigs(obj, "to_game", obj, NULL);
+}
+
+void do_char_to_game_trighooks(const char *info) {
+  CHAR_DATA *ch = NULL;
+  hookParseInfo(info, &ch);
+  do_char_trigs(ch, "to_game", ch, NULL);
+}
+
+void do_room_to_game_trighooks(const char *info) {
+  ROOM_DATA *rm = NULL;
+  hookParseInfo(info, &rm);
+  do_room_trigs(rm, "to_game", rm, NULL);
+}
+
 
 
 //*****************************************************************************
@@ -429,17 +532,25 @@
 //*****************************************************************************
 void init_trighooks(void) {
   // add all of our hooks to the game
-  hookAdd("give",      do_give_trighooks);
-  hookAdd("get",       do_get_trighooks);
-  hookAdd("drop",      do_drop_trighooks);
-  hookAdd("enter",     do_enter_trighooks);
-  hookAdd("exit",      do_exit_trighooks);
-  hookAdd("ask",       do_ask_trighooks);
-  hookAdd("say",       do_say_trighooks);
-  hookAdd("greet",     do_greet_trighooks);
-  hookAdd("wear",      do_wear_trighooks);
-  hookAdd("remove",    do_remove_trighooks);
-  hookAdd("reset",     do_reset_trighooks);
-  hookAdd("open_door", do_open_door_trighooks);
-  hookAdd("open_obj",  do_open_obj_trighooks);
+  hookAdd("give",           do_give_trighooks);
+  hookAdd("get",            do_get_trighooks);
+  hookAdd("drop",           do_drop_trighooks);
+  hookAdd("enter",          do_enter_trighooks);
+  hookAdd("exit",           do_exit_trighooks);
+  hookAdd("ask",            do_ask_trighooks);
+  hookAdd("say",            do_say_trighooks);
+  hookAdd("greet",          do_greet_trighooks);
+  hookAdd("wear",           do_wear_trighooks);
+  hookAdd("remove",         do_remove_trighooks);
+  hookAdd("reset",          do_reset_trighooks);
+  hookAdd("open_door",      do_open_door_trighooks);
+  hookAdd("open_obj",       do_open_obj_trighooks);
+  hookAdd("close_door",     do_close_door_trighooks);
+  hookAdd("close_obj",      do_close_obj_trighooks);
+  hookAdd("look_at_obj",    do_look_at_obj_trighooks);
+  hookAdd("look_at_char",   do_look_at_char_trighooks);
+  hookAdd("look_at_room",   do_look_at_room_trighooks);
+  hookAdd("obj_to_game",    do_obj_to_game_trighooks);
+  hookAdd("char_to_game",   do_char_to_game_trighooks);
+  hookAdd("room_to_game",   do_room_to_game_trighooks);
 }
diff -ruN ../nakedmudv3.7/src/set.c src/set.c
--- ../nakedmudv3.7/src/set.c	2008-05-31 00:17:59.000000000 -0400
+++ src/set.c	2009-03-02 01:00:40.000000000 -0500
@@ -129,14 +129,19 @@
   set->size++;
 }
 
-void setRemove(SET *set, void *elem) {
+void *setRemove(SET *set, void *elem) {
   // find out what bucket we belong to
   int hash_bucket = set->hash(elem) % set->num_buckets;
 
   // see if the bucket exists
-  if(set->buckets[hash_bucket] != NULL)
-    if(listRemoveWith(set->buckets[hash_bucket], elem, set->cmp))
+  if(set->buckets[hash_bucket] != NULL) {
+    if(listRemoveWith(set->buckets[hash_bucket], elem, set->cmp)) {
       set->size--;
+      return elem;
+    }
+  }
+
+  return NULL;
 }
 
 int setIn(SET *set, const void *elem) {
diff -ruN ../nakedmudv3.7/src/set.h src/set.h
--- ../nakedmudv3.7/src/set.h	2008-05-31 00:17:59.000000000 -0400
+++ src/set.h	2009-03-02 01:00:40.000000000 -0500
@@ -14,7 +14,7 @@
 SET  *newSet         (void);
 void  deleteSet      (SET *set);
 void  setPut         (SET *set, void *elem);
-void  setRemove      (SET *set, void *elem);
+void *setRemove      (SET *set, void *elem);
 int   setIn          (SET *set, const void *elem);
 int   setSize        (SET *set);
 LIST *setCollect     (SET *set);
diff -ruN ../nakedmudv3.7/src/set_val/set_val.c src/set_val/set_val.c
--- ../nakedmudv3.7/src/set_val/set_val.c	2008-05-31 00:17:59.000000000 -0400
+++ src/set_val/set_val.c	2009-03-02 01:00:40.000000000 -0500
@@ -165,7 +165,7 @@
     CHAR_DATA *tgt = get_player(name);
     if(tgt == NULL)
       send_to_char(ch, "No pfile for %s exists!\r\n", name);
-    else if(!charHasMoreUserGroups(ch, tgt)) {
+    else if(ch != tgt && bitIsSet(charGetUserGroups(tgt), "admin")) {
       send_to_char(ch, "Sorry, %s has just as many priviledges as you.\r\n", 
 		   HESHE(tgt));
       unreference_player(tgt);
@@ -200,7 +200,7 @@
     if(tgt == NULL)
       send_to_char(ch, "What was the target you were trying to modify?\r\n");
     else if(found == FOUND_CHAR) {
-      if(ch != tgt && !charHasMoreUserGroups(ch, tgt))
+      if(ch != tgt && bitIsSet(charGetUserGroups(tgt), "admin"))
 	send_to_char(ch, "Sorry, %s has just as many priviledges as you.\r\n", 
 		     HESHE(tgt));
       else
@@ -209,8 +209,9 @@
     else if(found == FOUND_OBJ)
       try_set(ch, tgt, obj_set_table, field, val);
     else if(found == FOUND_ROOM) {
-      if(!canEditZone(worldGetZone(gameworld,get_key_locale(roomGetClass(tgt))),
-		      ch))
+      ZONE_DATA *zone = worldGetZone(gameworld, get_key_locale(roomGetClass(tgt)));
+
+      if(zone != NULL && !canEditZone(zone, ch))
 	send_to_char(ch, "You are not authorized to edit that zone.\r\n");
       else
 	try_set(ch, tgt, room_set_table, field, val);
diff -ruN ../nakedmudv3.7/src/socials/socials.c src/socials/socials.c
--- ../nakedmudv3.7/src/socials/socials.c	2008-05-31 00:17:59.000000000 -0400
+++ src/socials/socials.c	2009-03-02 01:00:40.000000000 -0500
@@ -546,7 +546,9 @@
     remove_keyword(data->cmds, cmd);
 
     // remove the command from the command table
-    remove_cmd(cmd);
+    CMD_DATA *cdata = remove_cmd(cmd);
+    if(cdata != NULL)
+      deleteCmd(cdata);
 
     // if no links are left, delete the social
     if(!*data->cmds)
diff -ruN ../nakedmudv3.7/src/socket.c src/socket.c
--- ../nakedmudv3.7/src/socket.c	2008-12-06 00:20:20.000000000 -0500
+++ src/socket.c	2009-03-02 01:00:40.000000000 -0500
@@ -24,6 +24,7 @@
 #include "hooks.h"
 #include "scripts/scripts.h"
 #include "scripts/pyplugs.h"
+#include "dyn_vars/dyn_vars.h"
 
 
 
@@ -54,6 +55,7 @@
   int             lookup_status;
   int             control;
   int             uid;
+  double          idle;          // how many pulses have we been idle for?
 
   char          * page_string;   // the string that has been paged to us
   int             curr_page;     // the current page we're on
@@ -70,7 +72,7 @@
   z_stream      * out_compress;                /* MCCP support */
   unsigned char * out_compress_buf;            /* MCCP support */
 
-  HASHTABLE     * auxiliary;     // auxiliary data installed by other modules
+  AUX_TABLE     * auxiliary;     // auxiliary data installed by other modules
 };
 
 
@@ -82,6 +84,7 @@
   void *handler; // (* handler)(SOCKET_DATA *, char *);
   void  *prompt; // (*  prompt)(SOCKET_DATA *);
   bool   python;
+  char   *state; // what state does this input handler represent?
 } IH_PAIR;
 
 
@@ -102,6 +105,15 @@
 const unsigned char compress_will   [] = { IAC, WILL, TELOPT_COMPRESS,  '\0' };
 const unsigned char compress_will2  [] = { IAC, WILL, TELOPT_COMPRESS2, '\0' };
 
+// used to delete an input handler pair
+void deleteInputHandler(IH_PAIR *pair) {
+  if(pair->python) {
+    Py_XDECREF((PyObject *)pair->handler);
+    Py_XDECREF((PyObject *)pair->prompt);
+  }
+  if(pair->state) free(pair->state);
+  free(pair);
+}
 
 /*
  * Init_socket()
@@ -209,11 +221,11 @@
   }
 
   /* negotiate compression */
-  text_to_buffer(sock_new, (char *) compress_will2);
-  text_to_buffer(sock_new, (char *) compress_will);
+  // text_to_buffer(sock_new, (char *) compress_will2);
+  // text_to_buffer(sock_new, (char *) compress_will);
 
   /* send the greeting */
-  text_to_buffer(sock_new, bufferString(greeting));
+  // text_to_buffer(sock_new, bufferString(greeting));
 
   /* everything went as it was supposed to */
   return sock_new;
@@ -431,6 +443,7 @@
 
 void next_cmd_from_buffer(SOCKET_DATA *dsock) {
   // do we have stuff in our input list? If so, use that instead of inbuf
+  dsock->cmd_read = FALSE;
   if(listSize(dsock->input) > 0) {
     char *cmd = listPop(dsock->input);
     strncpy(dsock->next_command, cmd, MAX_BUFFER);
@@ -439,12 +452,15 @@
     free(cmd);
   }
   else {
-    int size = 0, i = 0, j = 0, telopt = 0;
-
+    int size = 0, i = 0, j = 0; //, telopt = 0;
+    static char iacopt[MAX_BUFFER];
+    bool found_iac = FALSE;
+    iacopt[0] = '\0';
+    
     // if theres already a command ready, we return
     if(dsock->next_command[0] != '\0')
       return;
-
+    
     // if there is nothing pending, then return
     if(dsock->inbuf[0] == '\0')
       return;
@@ -455,17 +471,69 @@
       size++;
 
     /* we only deal with real commands */
+    // I'm not really sure what this means, or does! -- Geoff
     if(dsock->inbuf[size] == '\0')
       return;
 
     // copy the next command into next_command
     for(; i < size; i++) {
+      // we have a system command. Try to parse it out
+      if(dsock->inbuf[i] == (signed char) IAC) {
+	int iac_i       = 0;
+	iacopt[iac_i++] = (signed char) dsock->inbuf[i++];
+	
+	// IAC escape sequence: IAC IAC
+	if(dsock->inbuf[i] == (signed char) IAC)
+	  iacopt[iac_i++] = (signed char) dsock->inbuf[i];
+	
+	// subnegotiation, read until the end of the sequence
+	if(dsock->inbuf[i] == (signed char) SB) {
+	  while(dsock->inbuf[i] != (signed char) SE)
+	    iacopt[iac_i++] = (signed char) dsock->inbuf[i++];
+	  iacopt[iac_i++] = (signed char) dsock->inbuf[i];
+	}
+
+	// basic three-character command
+	else if(dsock->inbuf[i] == (signed char) WILL || 
+		dsock->inbuf[i] == (signed char) WONT || 
+		dsock->inbuf[i] == (signed char) DO   || 
+		dsock->inbuf[i] == (signed char) DONT) {
+	  iacopt[iac_i++] = (signed char) dsock->inbuf[i++];
+	  iacopt[iac_i++] = (signed char) dsock->inbuf[i];
+	}
+	
+	// not sure what happened here! Something got busted in transit
+	else {
+	  iacopt[iac_i++] = dsock->inbuf[i];
+	}
+
+	// close off the command
+	iacopt[iac_i++] = '\0';
+
+	// did we find an IAC command? Notify the world!
+	if(*iacopt) {
+	  found_iac = TRUE;
+	  hookRun("receive_iac", hookBuildInfo("sk str", dsock, iacopt));
+	  //*iacopt = '\0';
+	}
+      }
+      
+      else if(isprint(dsock->inbuf[i]) && isascii(dsock->inbuf[i])) {
+	dsock->next_command[j++] = dsock->inbuf[i];
+      }
+      else {
+	// log_string("BAD CHARACTER %d", (unsigned int)dsock->inbuf[i]); 
+      }
+
+      /*
+       * THE OLD HANDLER
+       *
       if(dsock->inbuf[i] == (signed char) IAC)
 	telopt = 1;
       else if(telopt == 1 && (dsock->inbuf[i] == (signed char) DO || 
 			      dsock->inbuf[i] == (signed char) DONT))
 	telopt = 2;
-
+    
       // check for compression format
       else if(telopt == 2) {
 	unsigned char compress_opt = dsock->inbuf[i];
@@ -484,16 +552,18 @@
       else if(isprint(dsock->inbuf[i]) && isascii(dsock->inbuf[i])) {
 	dsock->next_command[j++] = dsock->inbuf[i];
       }
+      */
     }
+    
     dsock->next_command[j] = '\0';
-
+    
     // skip forward to the next line
     while(dsock->inbuf[size] == '\n' || dsock->inbuf[size] == '\r') {
-      dsock->cmd_read = TRUE;
-      dsock->bust_prompt = TRUE;   // seems like a good place to check
+      dsock->cmd_read    = TRUE;
+      dsock->bust_prompt = TRUE;
       size++;
     }
-
+    
     // use i as a static pointer
     i = size;
     
@@ -510,6 +580,7 @@
 
 bool flush_output(SOCKET_DATA *dsock) {
   bool  success = TRUE;
+  BUFFER   *buf = NULL;
 
   // run any hooks prior to flushing our text
   hookRun("flush", hookBuildInfo("sk", dsock));
@@ -519,11 +590,14 @@
      (!dsock->bust_prompt || !socketHasPrompt(dsock)))
     return success;
 
+  buf = newBuffer(1);
+
   // send our outbound text
   if(bufferLength(dsock->outbuf) > 0) {
     hookRun("process_outbound_text",  hookBuildInfo("sk", dsock));
     hookRun("finalize_outbound_text", hookBuildInfo("sk", dsock));
-    success = text_to_socket(dsock, bufferString(dsock->outbuf));
+    //success = text_to_socket(dsock, bufferString(dsock->outbuf));
+    bufferCat(buf, bufferString(dsock->outbuf));
     bufferClear(dsock->outbuf);
   }
 
@@ -532,11 +606,15 @@
     socketShowPrompt(dsock);
     hookRun("process_outbound_prompt",  hookBuildInfo("sk", dsock));
     hookRun("finalize_outbound_prompt", hookBuildInfo("sk", dsock));
-    success = text_to_socket(dsock, bufferString(dsock->outbuf));
+    //success = text_to_socket(dsock, bufferString(dsock->outbuf));
+    bufferCat(buf, bufferString(dsock->outbuf));
     bufferClear(dsock->outbuf);
     dsock->bust_prompt = FALSE;
   }
 
+  success = text_to_socket(dsock, bufferString(buf));
+  deleteBuffer(buf);
+
   // return our success
   return success;
 }
@@ -553,14 +631,14 @@
 //
 //*****************************************************************************
 void deleteSocket(SOCKET_DATA *sock) {
-  if(sock->hostname)         free(sock->hostname);
-  if(sock->page_string)      free(sock->page_string);
-  if(sock->text_editor)      deleteBuffer(sock->text_editor);
-  if(sock->outbuf)           deleteBuffer(sock->outbuf);
-  if(sock->input_handlers)   deleteListWith(sock->input_handlers, free);
-  if(sock->input)            deleteListWith(sock->input, free);
-  if(sock->command_hist)     deleteListWith(sock->command_hist, free);
-  if(sock->auxiliary)        deleteAuxiliaryData(sock->auxiliary);
+  if(sock->hostname)      free(sock->hostname);
+  if(sock->page_string)   free(sock->page_string);
+  if(sock->text_editor)   deleteBuffer(sock->text_editor);
+  if(sock->outbuf)        deleteBuffer(sock->outbuf);
+  if(sock->input_handlers)deleteListWith(sock->input_handlers,deleteInputHandler);
+  if(sock->input)         deleteListWith(sock->input, free);
+  if(sock->command_hist)  deleteListWith(sock->command_hist, free);
+  if(sock->auxiliary)     deleteAuxiliaryData(sock->auxiliary);
   free(sock);
 }
 
@@ -569,7 +647,7 @@
   if(sock_new->page_string)    free(sock_new->page_string);
   if(sock_new->text_editor)    deleteBuffer(sock_new->text_editor);
   if(sock_new->outbuf)         deleteBuffer(sock_new->outbuf);
-  if(sock_new->input_handlers) deleteListWith(sock_new->input_handlers, free);
+  if(sock_new->input_handlers) deleteListWith(sock_new->input_handlers, deleteInputHandler);
   if(sock_new->auxiliary)      deleteAuxiliaryData(sock_new->auxiliary);
   if(sock_new->input)          deleteListWith(sock_new->input, free);
   if(sock_new->command_hist)   deleteListWith(sock_new->command_hist, free);
@@ -583,7 +661,7 @@
   sock_new->lookup_status  = TSTATE_LOOKUP;
   sock_new->uid            = next_sock_uid++;
 
-  sock_new->text_editor    = newBuffer(MAX_BUFFER);
+  sock_new->text_editor    = newBuffer(1);
   sock_new->outbuf         = newBuffer(MAX_OUTPUT);
 }
 
@@ -777,8 +855,12 @@
     /* Ok, check for a new command */
     next_cmd_from_buffer(sock);
     
+    // are we idling?
+    if(!sock->cmd_read)
+      sock->idle +=  1.0 / PULSES_PER_SECOND;
     /* Is there a new command pending ? */
-    if (sock->cmd_read) {
+    else if (sock->cmd_read) {
+      sock->idle = 0.0;
       IH_PAIR *pair = listGet(sock->input_handlers, 0);
       if(pair->python == FALSE) {
 	void (* handler)(SOCKET_DATA *, char *) = pair->handler;
@@ -804,7 +886,10 @@
       if(listSize(sock->command_hist) > 100)
 	free(listRemoveNum(sock->command_hist, 100));
       sock->next_command[0] = '\0';
-      sock->cmd_read = FALSE;
+
+      // we save whether or not we read a command until our next call to
+      // input_handler(), at which time it is reset to FALSE if we didn't read
+      // sock->cmd_read = FALSE;
     }
 
 #ifdef MODULE_ALIAS
@@ -824,6 +909,12 @@
 
 int count_pages(const char *string) {
   int num_newlines = count_letters(string, '\n', strlen(string));
+  
+  // if we just have one extra line, ignore the paging prompt and just send
+  // the entire thing
+  if(num_newlines <= NUM_LINES_PER_PAGE + 1)
+    return 1;
+
   return ((num_newlines / NUM_LINES_PER_PAGE) + 
 	  (num_newlines % NUM_LINES_PER_PAGE != 0));
 }
@@ -874,10 +965,15 @@
     free(dsock->page_string);
   dsock->page_string = strdup(string);
   dsock->tot_pages   = count_pages(string);
-  dsock->curr_page   = 1;
-  show_page(dsock, 1);
-  if(dsock->tot_pages == 1)
+  
+  if(dsock->tot_pages == 1) {
+    text_to_buffer(dsock, dsock->page_string);
     delete_page(dsock);
+  }
+  else {
+    dsock->curr_page = 1;
+    show_page(dsock, 1);
+  }
 }
 
 void page_back(SOCKET_DATA *dsock) {
@@ -931,7 +1027,7 @@
 // a new handler that allows people to read long bits of text
 void  start_reader(SOCKET_DATA *dsock, const char *text) {
   // add a new input handler to control the reading
-  socketPushInputHandler(dsock, read_handler, read_prompt);
+  socketPushInputHandler(dsock, read_handler, read_prompt, "read text");
   
   // page the string
   page_string(dsock, text);
@@ -955,7 +1051,8 @@
   ITERATE_LIST(sock, sock_i) {
     compressEnd(sock, sock->compressing, FALSE);
     // kick off anyone who hasn't yet logged in a character
-    if (!socketGetChar(sock) || !charGetRoom(socketGetChar(sock))) {
+    if (!socketGetChar(sock) || !socketGetAccount(sock) || 
+	!charGetRoom(socketGetChar(sock))) {
       text_to_socket(sock, "\r\nSorry, we are rebooting. Come back in a few minutes.\r\n");
       close_socket(sock, FALSE);
     }
@@ -1019,27 +1116,32 @@
 
 void socketPushInputHandler  ( SOCKET_DATA *socket, 
 			       void handler(SOCKET_DATA *socket, char *input),
-			       void prompt (SOCKET_DATA *socket)) {
+			       void prompt (SOCKET_DATA *socket),
+			       const char *state) {
   IH_PAIR *pair = malloc(sizeof(IH_PAIR));
   pair->handler = handler;
   pair->prompt  = prompt;
   pair->python  = FALSE;
+  pair->state   = strdupsafe(state);
   listPush(socket->input_handlers, pair);
 }
 
-void socketPushPyInputHandler(SOCKET_DATA *sock, void *handler,void *prompt) {
+void socketPushPyInputHandler(SOCKET_DATA *sock, void *handler,void *prompt,
+			      const char *state) {
   IH_PAIR *pair = malloc(sizeof(IH_PAIR));
   pair->handler = handler;
   pair->prompt  = prompt;
   pair->python  = TRUE;
+  pair->state   = strdupsafe(state);
   Py_XINCREF((PyObject *)handler);
   Py_XINCREF((PyObject *)prompt);
   listPush(sock->input_handlers, pair);
 }
 
-void socketReplacePyInputHandler(SOCKET_DATA *sock, void *handler,void *prompt){
+void socketReplacePyInputHandler(SOCKET_DATA *sock, void *handler,void *prompt,
+				 const char *state){
   socketPopInputHandler(sock);
-  socketPushPyInputHandler(sock, handler, prompt);
+  socketPushPyInputHandler(sock, handler, prompt, state);
 }
 
 const char *socketGetLastCmd(SOCKET_DATA *sock) {
@@ -1051,24 +1153,26 @@
 
 void socketPopInputHandler   ( SOCKET_DATA *socket) {
   IH_PAIR *pair = listPop(socket->input_handlers);
-  if(pair->python) {
-    Py_XDECREF((PyObject *)pair->handler);
-    Py_XDECREF((PyObject *)pair->prompt);
-  }
-  free(pair);
+  if(pair != NULL)
+    deleteInputHandler(pair);
 }
 
 void socketReplaceInputHandler( SOCKET_DATA *socket,
 				void handler(SOCKET_DATA *socket, char *input),
-				void prompt (SOCKET_DATA *socket)) {
+				void prompt (SOCKET_DATA *socket),
+				const char *state) {
   socketPopInputHandler(socket);
-  socketPushInputHandler(socket, handler, prompt);
+  socketPushInputHandler(socket, handler, prompt, state);
 }
 
 void socketQueueCommand( SOCKET_DATA *sock, const char *cmd) {
   listQueue(sock->input, strdup(cmd));
 }
 
+bool socketHasCommand(SOCKET_DATA *sock) {
+  return sock->cmd_read;
+}
+
 int socketGetUID( SOCKET_DATA *dsock) {
   return dsock->uid;
 }
@@ -1099,7 +1203,7 @@
 }
 
 void *socketGetAuxiliaryData  ( SOCKET_DATA *sock, const char *name) {
-  return hashGet(sock->auxiliary, name);
+  return auxiliaryGet(sock->auxiliary, name);
 }
 
 const char *socketGetHostname(SOCKET_DATA *sock) {
@@ -1114,6 +1218,18 @@
   sock->bust_prompt = TRUE;
 }
 
+const char *socketGetState(SOCKET_DATA *sock) {
+  IH_PAIR *pair = listGet(sock->input_handlers, 0);
+  if(pair == NULL) 
+    return "";
+  else
+    return pair->state;
+}
+
+double socketGetIdleTime(SOCKET_DATA *sock) {
+  return sock->idle;
+}
+
 
 
 //*****************************************************************************
@@ -1285,7 +1401,6 @@
   return TRUE;
 }
 
-
 //
 // compress output
 //
diff -ruN ../nakedmudv3.7/src/socket.h src/socket.h
--- ../nakedmudv3.7/src/socket.h	2008-05-31 00:17:59.000000000 -0400
+++ src/socket.h	2009-03-02 01:00:40.000000000 -0500
@@ -43,12 +43,16 @@
 
 void socketPushInputHandler   ( SOCKET_DATA *socket, 
 			        void handler(SOCKET_DATA *socket, char *input),
-				void prompt (SOCKET_DATA *socket));
+				void prompt (SOCKET_DATA *socket),
+				const char *state);
 void socketReplaceInputHandler( SOCKET_DATA *socket,
 				void handler(SOCKET_DATA *socket, char *input),
-				void prompt (SOCKET_DATA *socket));
-void socketPushPyInputHandler   (SOCKET_DATA *sock, void *handler,void *prompt);
-void socketReplacePyInputHandler(SOCKET_DATA *sock, void *handler,void *prompt);
+				void prompt (SOCKET_DATA *socket),
+				const char *state);
+void socketPushPyInputHandler   (SOCKET_DATA *sock, void *handler,void *prompt,
+				 const char *state);
+void socketReplacePyInputHandler(SOCKET_DATA *sock, void *handler,void *prompt,
+				 const char *state);
 void socketPopInputHandler    ( SOCKET_DATA *socket);
 void *socketGetAuxiliaryData  ( SOCKET_DATA *sock, const char *name);
 const char *socketGetHostname ( SOCKET_DATA *sock);
@@ -60,6 +64,9 @@
 bool socketHasPrompt          ( SOCKET_DATA *sock);
 void socketBustPrompt         ( SOCKET_DATA *sock);
 void socketShowPrompt         ( SOCKET_DATA *sock);
+bool socketHasCommand         ( SOCKET_DATA *sock);
 const char *socketGetLastCmd  ( SOCKET_DATA *sock);
+const char *socketGetState    ( SOCKET_DATA *sock);
+double socketGetIdleTime      ( SOCKET_DATA *sock);
 
 #endif // SOCKET_H
